"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cleanUpSwearyString = exports.swearWords = void 0;
var swearsJson = require("./swears.json");
/** Array: get list of swear words. **/
exports.swearWords = swearsJson;
/** Function: replace swear words with a clean word instead.

Warning: probably not the most performant function.

@param stringToClean The string you want to be cleaned
@param options _Optional options object_ - `{ wordToUseInstead: "fluff" }` will result in the word "fluff" being used instead of the default asterisks (****).
**/
var cleanUpSwearyString = function (stringToClean, _a) {
    var _b = _a === void 0 ? {} : _a, wordToUseInstead = _b.wordToUseInstead;
    var arrayToClean = stringToClean.split(" ");
    var cleanedArray = arrayToClean.map(function (word) {
        var useWordInstead = !!(wordToUseInstead === null || wordToUseInstead === void 0 ? void 0 : wordToUseInstead.length);
        var swearsInWord = exports.swearWords.filter(function (swear) {
            return word.toUpperCase().includes(swear.toUpperCase());
        }); //?
        var escapeRegExp = function (text) {
            return text.replace(/[.*+\-?^${}()|[\]\\]/g, "\\$&");
        };
        var replaceAll = function (text, find, replace) {
            return text.replace(new RegExp(escapeRegExp(find), "gi"), replace);
        };
        var startsWithCapital = function (word) {
            return word.charAt(0) === word.charAt(0).toUpperCase();
        };
        var capitalizeFirstLetter = function (word) {
            return "" + word.charAt(0).toUpperCase() + word.slice(1);
        };
        var getReplacement = function (swear) {
            if (useWordInstead) {
                return startsWithCapital(swear)
                    ? capitalizeFirstLetter(wordToUseInstead)
                    : wordToUseInstead;
            }
            else {
                return "*".repeat(swear.length);
            }
        };
        if (swearsInWord.length > 0) {
            var cleanedWord_1 = word;
            var splitSwearsInSwearWord = exports.swearWords.filter(function (swearWordFromMainList) {
                return word.toUpperCase().includes(swearWordFromMainList.toUpperCase());
            });
            splitSwearsInSwearWord.forEach(function (swear) {
                cleanedWord_1 = replaceAll(cleanedWord_1, swear, getReplacement(swear));
            });
            return cleanedWord_1;
        }
        return word;
    });
    return cleanedArray.join(" ");
};
exports.cleanUpSwearyString = cleanUpSwearyString;
